(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('class-transformer'), require('@angular/core'), require('@angular/common/http'), require('immutable'), require('rxjs/Observable'), require('url-parse'), require('rxjs/BehaviorSubject'), require('rxjs/Subject'), require('rxjs/observable/of'), require('rxjs/operators'), require('class-validator'), require('rxjs/observable/throw'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define('ngx-repository', ['exports', 'class-transformer', '@angular/core', '@angular/common/http', 'immutable', 'rxjs/Observable', 'url-parse', 'rxjs/BehaviorSubject', 'rxjs/Subject', 'rxjs/observable/of', 'rxjs/operators', 'class-validator', 'rxjs/observable/throw', '@angular/common'], factory) :
	(factory((global['ngx-repository'] = {}),global.classTransformer,global.ng.core,global.ng.common.http,global.immutable,global.Rx,global.parseImported,global.Rx,global.Rx,global.Rx.Observable,global.Rx.Observable.prototype,global.classValidator,global.Rx.Observable,global.ng.common));
}(this, (function (exports,classTransformer,core,http,immutable,Observable,parseImported,BehaviorSubject,Subject,of,operators,classValidator,_throw,common) { 'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.
See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */
var extendStatics = Object.setPrototypeOf ||
    ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
    function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}









function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}
function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

var ProviderActionEnum = {
    Action: 0,
    Create: 1,
    Append: 2,
    Update: 3,
    Patch: 4,
    Delete: 5,
    Load: 6,
    LoadAll: 7,
};
ProviderActionEnum[ProviderActionEnum.Action] = "Action";
ProviderActionEnum[ProviderActionEnum.Create] = "Create";
ProviderActionEnum[ProviderActionEnum.Append] = "Append";
ProviderActionEnum[ProviderActionEnum.Update] = "Update";
ProviderActionEnum[ProviderActionEnum.Patch] = "Patch";
ProviderActionEnum[ProviderActionEnum.Delete] = "Delete";
ProviderActionEnum[ProviderActionEnum.Load] = "Load";
ProviderActionEnum[ProviderActionEnum.LoadAll] = "LoadAll";
var PaginationMeta = /** @class */ (function () {
    function PaginationMeta(data) {
        classTransformer.plainToClassFromExist(this, data);
    }
    return PaginationMeta;
}());
var RestProviderActionHandlers = /** @class */ (function () {
    function RestProviderActionHandlers() {
    }
    RestProviderActionHandlers.prototype.getRequest = function (requestUrl, data, requestOptions, optionsList, action, useDefault) {
        var request;
        if (useDefault !== true) {
            optionsList.forEach(function (eachOptions) {
                if (eachOptions !== undefined &&
                    eachOptions.actionOptions !== undefined &&
                    eachOptions.actionOptions.request !== undefined) {
                    request = eachOptions.actionOptions.request;
                    return request;
                }
            });
        }
        if (request !== undefined) {
            return request(requestUrl, data, requestOptions);
        }
        return undefined;
    };
    RestProviderActionHandlers.prototype.getResponseData = function (data, optionsList, action, useDefault) {
        var responseData;
        if (useDefault !== true) {
            optionsList.forEach(function (eachOptions) {
                if (eachOptions !== undefined && eachOptions.actionOptions !== undefined &&
                    eachOptions.actionOptions.responseData !== undefined) {
                    responseData = eachOptions.actionOptions.responseData(data, action);
                    return responseData;
                }
            });
        }
        if (responseData !== undefined) {
            return responseData;
        }
        return data.body;
    };
    RestProviderActionHandlers.prototype.getResponsePaginationMeta = function (data, optionsList, action, useDefault) {
        var paginationMeta;
        if (useDefault !== true) {
            optionsList.forEach(function (eachOptions) {
                if (eachOptions !== undefined &&
                    eachOptions.actionOptions !== undefined && eachOptions.actionOptions.responsePaginationMeta !== undefined) {
                    paginationMeta = eachOptions.actionOptions.responsePaginationMeta(data, action);
                    return paginationMeta;
                }
            });
        }
        if (paginationMeta !== undefined) {
            return paginationMeta;
        }
        paginationMeta = new PaginationMeta();
        var xTotalCount = NaN;
        var keys = data.headers ? (data.headers.keys ? data.headers.keys() : data.headers) : [];
        keys.forEach(function (key) {
            if (key.toLowerCase() === 'x-total-count') {
                xTotalCount = +data.headers.get(key);
            }
        });
        paginationMeta.totalResults = isNaN(xTotalCount) ? 10000 : xTotalCount;
        return paginationMeta;
    };
    RestProviderActionHandlers.prototype.getRequestQuery = function (currentUrl, filter, optionsList, action, useDefault) {
        var query;
        if (useDefault !== true) {
            optionsList.forEach(function (eachOptions) {
                if (eachOptions !== undefined && eachOptions.actionOptions !== undefined &&
                    eachOptions.actionOptions.requestQuery !== undefined) {
                    query = eachOptions.actionOptions.requestQuery(currentUrl, filter, action);
                    return query;
                }
            });
        }
        if (query !== undefined) {
            return query;
        }
        for (var key in filter) {
            if (filter.hasOwnProperty(key)) {
                var value = filter[key];
                if (!currentUrl.includes("?" + key + "=") && !currentUrl.includes("&" + key + "=")) {
                    currentUrl = currentUrl + ((currentUrl.indexOf('?') === -1 ? '?' : '&') + (key + "=" + filter[key]));
                }
            }
        }
        return currentUrl;
    };
    RestProviderActionHandlers.prototype.getRequestUrl = function (key, data, optionsList, action, useDefault) {
        var requestUrl;
        optionsList.forEach(function (eachOptions) {
            if (eachOptions !== undefined && eachOptions.actionOptions !== undefined &&
                eachOptions.actionOptions.requestUrl !== undefined) {
                requestUrl = eachOptions.actionOptions.requestUrl(key, data, action);
                return requestUrl;
            }
        });
        if (requestUrl !== undefined) {
            return requestUrl;
        }
        var apiUrl = '';
        var pluralName = '';
        if (useDefault !== true) {
            optionsList.forEach(function (eachOptions) {
                if (eachOptions !== undefined && eachOptions.apiUrl !== undefined) {
                    apiUrl = eachOptions.apiUrl;
                }
                if (eachOptions !== undefined && eachOptions.pluralName !== undefined) {
                    pluralName = eachOptions.pluralName;
                }
            });
        }
        if (action === ProviderActionEnum.Action) {
            return apiUrl + '/' + pluralName + '/' + key;
        }
        if (action === ProviderActionEnum.Create) {
            return apiUrl + '/' + pluralName;
        }
        if (action === ProviderActionEnum.Update) {
            return apiUrl + '/' + pluralName + '/' + key;
        }
        if (action === ProviderActionEnum.Patch) {
            return apiUrl + '/' + pluralName + '/' + key;
        }
        if (action === ProviderActionEnum.Load) {
            return apiUrl + '/' + pluralName + '/' + key;
        }
        if (action === ProviderActionEnum.Delete) {
            return apiUrl + '/' + pluralName + '/' + key;
        }
        if (action === ProviderActionEnum.LoadAll) {
            return apiUrl + '/' + pluralName;
        }
    };
    RestProviderActionHandlers.prototype.getRequestOptions = function (key, data, optionsList, action, useDefault) {
        var requestOptions = {
            observe: 'response'
        };
        if (useDefault !== true) {
            optionsList.reverse().forEach(function (eachOptions) {
                if (eachOptions !== undefined && eachOptions.actionOptions !== undefined &&
                    eachOptions.actionOptions.requestOptions !== undefined) {
                    var actionOptionsRequestOptions = eachOptions.actionOptions.requestOptions(key, data, action);
                    if (actionOptionsRequestOptions.headers !== undefined) {
                        requestOptions.headers = actionOptionsRequestOptions.headers;
                    }
                    if (actionOptionsRequestOptions.observe !== undefined) {
                        requestOptions.observe = actionOptionsRequestOptions.observe;
                    }
                    if (actionOptionsRequestOptions.params !== undefined) {
                        requestOptions.params = actionOptionsRequestOptions.params;
                    }
                    if (actionOptionsRequestOptions.reportProgress !== undefined) {
                        requestOptions.reportProgress = actionOptionsRequestOptions.reportProgress;
                    }
                    if (actionOptionsRequestOptions.responseType !== undefined) {
                        requestOptions.responseType = actionOptionsRequestOptions.responseType;
                    }
                    if (actionOptionsRequestOptions.withCredentials !== undefined) {
                        requestOptions.withCredentials = actionOptionsRequestOptions.withCredentials;
                    }
                }
            });
        }
        return (requestOptions);
    };
    RestProviderActionHandlers.prototype.getRequestCreateType = function (optionsList, action, useDefault) {
        var requestCreateType;
        if (useDefault !== true) {
            optionsList.forEach(function (eachOptions) {
                if (eachOptions !== undefined && eachOptions.actionOptions !== undefined &&
                    eachOptions.actionOptions.requestCreateType !== undefined) {
                    requestCreateType = eachOptions.actionOptions.requestCreateType(action);
                    return requestCreateType;
                }
            });
        }
        if (requestCreateType !== undefined) {
            return requestCreateType;
        }
        return 'create';
    };
    return RestProviderActionHandlers;
}());
RestProviderActionHandlers.decorators = [
    { type: core.Injectable },
];
var MockProviderActionHandlers = /** @class */ (function (_super) {
    __extends(MockProviderActionHandlers, _super);
    function MockProviderActionHandlers() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return MockProviderActionHandlers;
}(RestProviderActionHandlers));
MockProviderActionHandlers.decorators = [
    { type: core.Injectable },
];
var Model = /** @class */ (function () {
    function Model() {
    }
    return Model;
}());
Model.strings = {};
Model.fields = [];
Model.nested = {};
var ProviderError = /** @class */ (function (_super) {
    __extends(ProviderError, _super);
    function ProviderError(error) {
        var _this = _super.call(this, error instanceof Error ? error.message : (error)) || this;
        _this.error = error;
        Object.setPrototypeOf(_this, ProviderError.prototype);
        return _this;
    }
    return ProviderError;
}(Error));
var ValidatorError = /** @class */ (function (_super) {
    __extends(ValidatorError, _super);
    function ValidatorError(errors) {
        var _this = _super.call(this, Array.isArray(errors) ? JSON.stringify(errors) : (errors)) || this;
        _this.errors = errors;
        Object.setPrototypeOf(_this, ValidatorError.prototype);
        return _this;
    }
    return ValidatorError;
}(Error));
var parse = parseImported;
var FakeHttpClient = /** @class */ (function () {
    function FakeHttpClient(items, options) {
        this._idField = 'id';
        this._apiUrlPrefix = '/api/';
        this._pageQueryParam = 'page';
        this._limitQueryParam = 'limit';
        this._searchTextQueryParam = 'search';
        if (options) {
            if (options.idField !== undefined) {
                this._idField = options.idField;
            }
            if (options.apiUrlPrefix !== undefined) {
                this._apiUrlPrefix = options.apiUrlPrefix;
            }
            if (options.pageQueryParam !== undefined) {
                this._pageQueryParam = options.pageQueryParam;
            }
            if (options.limitQueryParam !== undefined) {
                this._limitQueryParam = options.limitQueryParam;
            }
            if (options.searchTextQueryParam !== undefined) {
                this._searchTextQueryParam = options.searchTextQueryParam;
            }
        }
        if (items !== undefined) {
            this.setItems(items);
        }
        else {
            this.mockedItems = immutable.List([]);
        }
    }
    FakeHttpClient.prototype.setItems = function (items) {
        this.mockedItems = immutable.List(items);
    };
    FakeHttpClient.prototype.genId = function () {
        var _this = this;
        var currentMax = 0;
        this.mockedItems.map(function (mapItem) { return Math.abs(mapItem[_this._idField]) > currentMax ?
            currentMax = Math.abs(mapItem[_this._idField]) :
            null; });
        return (currentMax + 1) * -1;
    };
    FakeHttpClient.prototype.parseUrl = function (url, data) {
        var uri = parse(url, true);
        var arrWithoutApi = uri.pathname.split(this._apiUrlPrefix);
        var arr = arrWithoutApi[arrWithoutApi.length - 1].split('/');
        var entityName = arr.length === 2 ? arr[arr.length - 2] : arr[arr.length - 1];
        var entityKey = arr.length === 2 ? arr[arr.length - 1] : undefined;
        var page = uri.query[this._pageQueryParam];
        var limit = uri.query[this._limitQueryParam];
        var searchText = uri.query[this._searchTextQueryParam];
        return {
            name: entityName,
            key: entityKey,
            query: uri.query,
            uri: uri,
            page: page,
            limit: limit,
            searchText: searchText
        };
    };
    FakeHttpClient.prototype.checkWordInData = function (data, word) {
        var _this = this;
        var result = Object.keys(data).filter(function (key) {
            if (data[key] instanceof Object) {
                return _this.checkWordInData(data[key], word);
            }
            if (!isNaN(+data[key])) {
                return +data[key] === +word;
            }
            return data[key] ? ((data[key])).toLowerCase().indexOf(word.toLowerCase()) !== -1 : false;
        });
        return result.length > 0;
    };
    FakeHttpClient.prototype.get = function (url, options) {
        var _this = this;
        return new Observable.Observable(function (observer) {
            var urlData = _this.parseUrl(url);
            var data = {};
            var newBody;
            if (urlData.key) {
                var foundedIndex = _this.mockedItems.findIndex(function (item) { return +item[_this._idField] === +urlData.key || (item[_this._idField]) === (urlData.key); });
                if (foundedIndex !== -1) {
                    newBody = _this.mockedItems.get(foundedIndex);
                }
            }
            else {
                var count_1 = 0;
                var xTotalCount_1 = 0;
                var startIndex_1 = ((+urlData.page > 1 ? +urlData.page - 1 : 0) * +urlData.limit) + 1;
                var filtredItems = _this.mockedItems.filter(function (item, index) {
                    if (urlData.searchText && !_this.checkWordInData(item, urlData.searchText)) {
                        return false;
                    }
                    else {
                        xTotalCount_1++;
                    }
                    if (index >= startIndex_1 - 1 && count_1 < +urlData.limit) {
                        count_1++;
                        return true;
                    }
                    else {
                        return false;
                    }
                });
                newBody = filtredItems.toArray();
                data.headers = new http.HttpHeaders({
                    'X-Total-Count': xTotalCount_1.toString()
                });
            }
            data.body = newBody;
            observer.next(data);
        });
    };
    FakeHttpClient.prototype.post = function (url, body, options) {
        var _this = this;
        return new Observable.Observable(function (observer) {
            if (!body[_this._idField]) {
                body[_this._idField] = _this.genId();
            }
            _this.mockedItems = _this.mockedItems.unshift(body);
            var data = { headers: new http.HttpHeaders(), body: body };
            observer.next(data);
        });
    };
    FakeHttpClient.prototype.put = function (url, body, options) {
        var _this = this;
        return new Observable.Observable(function (observer) {
            var urlData = _this.parseUrl(url);
            var foundedIndex = _this.mockedItems.findIndex(function (item) { return +item[_this._idField] === +urlData.key || (item[_this._idField]) === (urlData.key); });
            if (foundedIndex !== -1) {
                _this.mockedItems = _this.mockedItems.set(foundedIndex, body);
            }
            var data = { headers: new http.HttpHeaders(), body: body };
            observer.next(data);
        });
    };
    FakeHttpClient.prototype.delete = function (url, options) {
        var _this = this;
        return new Observable.Observable(function (observer) {
            var urlData = _this.parseUrl(url);
            var foundedIndex = _this.mockedItems.findIndex(function (item) { return +item[_this._idField] === +urlData.key || (item[_this._idField]) === (urlData.key); });
            if (foundedIndex !== -1) {
                _this.mockedItems = _this.mockedItems.delete(foundedIndex);
            }
            var data = { headers: new http.HttpHeaders(), body: true };
            observer.next(data);
        });
    };
    FakeHttpClient.prototype.patch = function (url, body, options) {
        var _this = this;
        return new Observable.Observable(function (observer) {
            var urlData = _this.parseUrl(url);
            var foundedIndex = _this.mockedItems.findIndex(function (item) { return +item[_this._idField] === +urlData.key || (item[_this._idField]) === (urlData.key); });
            if (foundedIndex !== -1) {
                var newBody = _this.mockedItems.get(foundedIndex);
                for (var objectKey in body) {
                    if (body[urlData.key] !== undefined) {
                        newBody[urlData.key] = body[urlData.key];
                    }
                }
                _this.mockedItems = _this.mockedItems.set(foundedIndex, newBody);
            }
            var data = { headers: new http.HttpHeaders(), body: body };
            observer.next(data);
        });
    };
    return FakeHttpClient;
}());
var Provider = /** @class */ (function () {
    function Provider(injector, factoryModel) {
        this.injector = injector;
        this.factoryModel = factoryModel;
        this.delay = 0;
        this.items$ = new BehaviorSubject.BehaviorSubject(immutable.List([]));
        this.action$ = new Subject.Subject();
        this.create$ = new Subject.Subject();
        this.append$ = new Subject.Subject();
        this.update$ = new Subject.Subject();
        this.patch$ = new Subject.Subject();
        this.delete$ = new Subject.Subject();
        this.load$ = new Subject.Subject();
        this.loadAll$ = new Subject.Subject();
        this.actionIsActive$ = new BehaviorSubject.BehaviorSubject(false);
        this.createIsActive$ = new BehaviorSubject.BehaviorSubject(false);
        this.updateIsActive$ = new BehaviorSubject.BehaviorSubject(false);
        this.deleteIsActive$ = new BehaviorSubject.BehaviorSubject(false);
        this.loadIsActive$ = new BehaviorSubject.BehaviorSubject(false);
        this.loadAllIsActive$ = new BehaviorSubject.BehaviorSubject(false);
        this.paginationMeta$ = new BehaviorSubject.BehaviorSubject(new PaginationMeta());
        this.destroy$ = new Subject.Subject();
    }
    Provider.prototype.instanceofFactoryModel = function (data) {
        return data instanceof this.factoryModel;
    };
    Provider.prototype.instanceofNestedFactoryModel = function (data) {
        var _this = this;
        return this.factoryModel &&
            this.factoryModel.nested &&
            Object.keys(this.factoryModel.nested).
                filter(function (key) { return data instanceof _this.factoryModel.nested[key]; }).length > 0;
    };
    Provider.prototype.updateNestedFactoryModel = function (data) {
        var _this = this;
        Object.keys(this.factoryModel.nested).forEach(function (key) { return _this.items$.next(_this.items$.getValue().map(function (item) {
            if (item[key]) {
                if (Array.isArray(item[key])) {
                    item[key].forEach(function (eachItem, index) {
                        if (eachItem.id === data.id) {
                            item[key][index] = data;
                        }
                    });
                }
                else {
                    item[key] = data;
                }
                _this.update(item.id, item, { globalEventIsActive: false });
            }
            return item;
        }).toList()); });
    };
    Provider.prototype.deleteNestedFactoryModel = function (data) {
        var _this = this;
        Object.keys(this.factoryModel.nested).forEach(function (key) { return _this.items$.next(_this.items$.getValue().map(function (item) {
            if (item[key]) {
                if (Array.isArray(item[key])) {
                    item[key] = item[key].filter(function (eachItem) { return eachItem.id !== data.id; });
                }
                else {
                    item[key] = undefined;
                }
                _this.update(item.id, item, { globalEventIsActive: false });
            }
            return item;
        }).toList()); });
    };
    Provider.prototype.plainToClass = function (data, action, classTransformOptions) {
        var model;
        if (!(data instanceof this.factoryModel)) {
            model = (classTransformer.plainToClassFromExist(new this.factoryModel(), data, classTransformOptions));
        }
        else {
            model = (data);
        }
        return model;
    };
    Provider.prototype.classToPlain = function (model, action, classTransformOptions) {
        return classTransformer.classToPlainFromExist(model, {}, classTransformOptions);
    };
    Provider.prototype.classToClass = function (model, classTransformOptions) {
        return classTransformer.classToClass(model, classTransformOptions);
    };
    Provider.prototype.action = function (key, data, options) {
        return of.of(data).pipe(operators.delay(this.delay));
    };
    Provider.prototype.save = function (model, options) {
        if (model.id === undefined) {
            return this.create(model, options);
        }
        return this.update(model.id, model, options);
    };
    Provider.prototype.create = function (model, options) {
        return of.of(model).pipe(operators.delay(this.delay));
    };
    Provider.prototype.append = function (model, options) {
        return of.of(model).pipe(operators.delay(this.delay));
    };
    Provider.prototype.update = function (key, model, options) {
        return of.of(model).pipe(operators.delay(this.delay));
    };
    Provider.prototype.patch = function (key, model, options) {
        return of.of(model).pipe(operators.delay(this.delay));
    };
    Provider.prototype.delete = function (key, options) {
        var newModel = this.plainToClass({ id: key }, ProviderActionEnum.Delete, options && options.classTransformOptions ?
            options.classTransformOptions :
            undefined);
        return of.of(newModel).pipe(operators.delay(this.delay));
    };
    Provider.prototype.load = function (key, options) {
        var newModel = this.plainToClass({ id: key }, ProviderActionEnum.Delete, options && options.classTransformOptions ?
            options.classTransformOptions :
            undefined);
        return of.of(newModel).pipe(operators.delay(this.delay));
    };
    Provider.prototype.loadAll = function (filter, options) {
        var newModels = [this.plainToClass({}, ProviderActionEnum.Delete, options && options.classTransformOptions ?
                options.classTransformOptions :
                undefined)];
        return of.of(newModels).pipe(operators.delay(this.delay));
    };
    Provider.prototype.calcPaginationMetaByOptions = function (options) {
        var paginationMeta = this.paginationMeta$.getValue();
        paginationMeta.totalResults =
            (options === undefined ||
                options.paginationMeta === undefined ||
                options.paginationMeta.totalResults === undefined) ? paginationMeta.totalResults : options.paginationMeta.totalResults;
        paginationMeta.perPage =
            (options === undefined ||
                options.paginationMeta === undefined ||
                options.paginationMeta.perPage === undefined) ? paginationMeta.perPage : options.paginationMeta.perPage;
        paginationMeta.curPage =
            (options === undefined ||
                options.paginationMeta === undefined ||
                options.paginationMeta.curPage === undefined) ? paginationMeta.curPage : options.paginationMeta.curPage;
        paginationMeta.perPage = paginationMeta.perPage === undefined ? 10 : paginationMeta.perPage;
        paginationMeta.curPage = paginationMeta.curPage === undefined ? 1 : paginationMeta.curPage;
        return this.calcPaginationMeta(paginationMeta);
    };
    Provider.prototype.calcPaginationMeta = function (newPaginationMeta) {
        var paginationMeta = this.paginationMeta$.getValue();
        if (newPaginationMeta.perPage !== undefined) {
            paginationMeta.perPage = newPaginationMeta.perPage;
        }
        if (newPaginationMeta.totalResults !== undefined) {
            paginationMeta.totalResults = newPaginationMeta.totalResults;
            paginationMeta.totalPages = Math.ceil(newPaginationMeta.totalResults / paginationMeta.perPage);
        }
        else {
            if (newPaginationMeta.totalPages !== undefined) {
                paginationMeta.totalResults = undefined;
                paginationMeta.totalPages = newPaginationMeta.totalPages;
            }
        }
        if (newPaginationMeta.curPage !== undefined) {
            paginationMeta.curPage = newPaginationMeta.curPage;
        }
        if (paginationMeta.totalPages < paginationMeta.curPage) {
            paginationMeta.curPage = paginationMeta.totalPages;
        }
        if (paginationMeta.curPage === 0) {
            paginationMeta.curPage = 1;
        }
        this.paginationMeta$.next(paginationMeta);
        return this.paginationMeta$.getValue();
    };
    Provider.prototype.reloadAll = function () { };
    Provider.prototype.checkFilterAndOptions = function () { };
    Provider.prototype.setOptions = function (options) { };
    Provider.prototype.getOptions = function () {
        return {};
    };
    Provider.prototype.reconfigItems = function () { };
    return Provider;
}());
var RestProvider = /** @class */ (function (_super) {
    __extends(RestProvider, _super);
    function RestProvider(injector, factoryModel, options) {
        var _this = _super.call(this, injector, factoryModel) || this;
        _this.injector = injector;
        _this.factoryModel = factoryModel;
        _this.options = options;
        _this.initFakeHttpClient();
        _this.init();
        return _this;
    }
    RestProvider.prototype.initFakeHttpClient = function () {
        var restOptions = this.options === undefined ? undefined : ((this.options)).restOptions;
        if (restOptions) {
            this.restOptions = restOptions;
        }
        if (!this.restOptions) {
            this.restOptions = {};
            this.restOptions.idField = 'id';
            this.restOptions.pageQueryParam = 'page';
            this.restOptions.limitQueryParam = 'limit';
            this.restOptions.searchTextQueryParam = 'search';
        }
        this.fakeHttpClient = new FakeHttpClient([], this.restOptions);
    };
    RestProvider.prototype.init = function () {
        this.httpClient = this.injector.get(http.HttpClient);
        this.providerActionHandlers = this.injector.get(RestProviderActionHandlers);
        this.setOptions((this.options));
    };
    RestProvider.prototype.getOptions = function () {
        return this.options;
    };
    RestProvider.prototype.setOptions = function (options) {
        var filter = options === undefined ? undefined : options.filter;
        options = Object.assign({}, this.options, options);
        var autoload = options === undefined ? undefined : options.autoload;
        var pluralName = options === undefined ? undefined : options.pluralName;
        var name = options === undefined ? undefined : options.name;
        var apiUrl = options === undefined ? undefined : options.apiUrl;
        var restOptions = options === undefined ? undefined : options.restOptions;
        if (autoload !== undefined) {
            this.autoload = autoload;
        }
        if (pluralName !== undefined) {
            this.pluralName = pluralName;
        }
        if (name !== undefined) {
            this.name = name;
        }
        if (apiUrl !== undefined) {
            this.apiUrl = apiUrl;
        }
        if (filter !== undefined) {
            this.filter = Object.assign({}, filter);
        }
        options.autoload = this.autoload;
        options.pluralName = this.pluralName;
        options.name = this.name;
        options.apiUrl = this.apiUrl;
        options.filter = Object.assign({}, this.filter);
        this.options = options;
        this.calcPaginationMetaByOptions(options);
        if (this.autoload !== false) {
            this._loadAll(this.filter, this.prevOptions).pipe(operators.first()).subscribe();
        }
    };
    RestProvider.prototype.action = function (key, data, options) {
        var _this = this;
        this.actionIsActive$.next(true);
        var useDefault = false;
        var errors = classValidator.validateSync(data, options && options.classValidatorOptions ?
            options.classValidatorOptions :
            { validationError: { target: false } });
        if (errors.length > 0 && (!options || options.globalEventIsActive !== false)) {
            return _throw._throw(new ValidatorError(errors));
        }
        var optionsList = [{ actionOptions: options }, (this.options)];
        var requestUrl = this.providerActionHandlers.getRequestUrl(key, data, optionsList, ProviderActionEnum.Action, useDefault);
        var requestOptions = this.providerActionHandlers.getRequestOptions(key, data, optionsList, ProviderActionEnum.Action, useDefault);
        var request = this.providerActionHandlers.getRequest(requestUrl, data, requestOptions, optionsList, ProviderActionEnum.Action, useDefault);
        if (!request) {
            request = this.httpClient.post(requestUrl, data, requestOptions);
        }
        return request.pipe(operators.map(function (responseData) { return _this.providerActionHandlers.getResponseData(responseData, optionsList, ProviderActionEnum.Action, useDefault); }), operators.map(function (actionData) {
            if (options === undefined ||
                options.globalEventIsActive !== false ||
                options.globalEventIsActiveResolver !== undefined) {
                if (options === undefined || options.globalEventIsActiveResolver === undefined ||
                    options.globalEventIsActiveResolver({
                        actionKey: key,
                        requestData: data,
                        responseData: actionData
                    }, ProviderActionEnum.Action)) {
                    _this.action$.next({
                        actionKey: key,
                        requestData: data,
                        responseData: actionData
                    });
                }
            }
            _this.actionIsActive$.next(false);
            return actionData;
        }));
    };
    RestProvider.prototype.create = function (model, options) {
        var _this = this;
        this.createIsActive$.next(true);
        var useDefault = (options && options.useFakeHttpClient === true) || this.httpClient instanceof FakeHttpClient;
        model = this.plainToClass(model, ProviderActionEnum.Create, options && options.classTransformOptions ?
            options.classTransformOptions :
            undefined);
        var errors = classValidator.validateSync(model, options && options.classValidatorOptions ?
            options.classValidatorOptions :
            { validationError: { target: false } });
        if (errors.length > 0 && (!options || options.globalEventIsActive !== false)) {
            return _throw._throw(new ValidatorError(errors));
        }
        var optionsList = [{ actionOptions: options }, (this.options)];
        var isCreate = this.providerActionHandlers.getRequestCreateType(optionsList, ProviderActionEnum.Create, useDefault) === 'create';
        var object;
        if (isCreate === true) {
            object = this.classToPlain(model, ProviderActionEnum.Create, options && options.classTransformOptions ?
                options.classTransformOptions :
                undefined);
        }
        else {
            object = this.classToPlain(model, ProviderActionEnum.Append, options && options.classTransformOptions ?
                options.classTransformOptions :
                undefined);
        }
        var requestUrl = this.providerActionHandlers.getRequestUrl(undefined, object, optionsList, isCreate ? ProviderActionEnum.Create : ProviderActionEnum.Append, useDefault);
        var requestOptions = this.providerActionHandlers.getRequestOptions(undefined, object, optionsList, isCreate ? ProviderActionEnum.Create : ProviderActionEnum.Append, useDefault);
        var request = this.providerActionHandlers.getRequest(requestUrl, object, requestOptions, optionsList, isCreate ? ProviderActionEnum.Create : ProviderActionEnum.Append, useDefault);
        if (!request) {
            request = (options === undefined || options.useFakeHttpClient !== true ? this.httpClient : this.fakeHttpClient).
                post(requestUrl, object, requestOptions);
        }
        return request.pipe(operators.map(function (responseData) { return _this.providerActionHandlers.getResponseData(responseData, optionsList, isCreate ? ProviderActionEnum.Create : ProviderActionEnum.Append, useDefault); }), operators.map(function (createdItem) {
            var createdModel;
            if (isCreate === true) {
                createdModel = _this.plainToClass(createdItem, ProviderActionEnum.Create, options && options.classTransformOptions ?
                    options.classTransformOptions :
                    undefined);
                _this.items$.next(_this.items$.getValue().unshift(createdModel));
            }
            else {
                createdModel = _this.plainToClass(createdItem, ProviderActionEnum.Append, options && options.classTransformOptions ?
                    options.classTransformOptions :
                    undefined);
                _this.items$.next(_this.items$.getValue().push(createdModel));
            }
            var paginationMeta = _this.paginationMeta$.getValue();
            _this.calcPaginationMeta({ totalResults: paginationMeta.totalResults + 1 });
            _this.reconfigItems();
            if (options === undefined ||
                options.globalEventIsActive !== false ||
                options.globalEventIsActiveResolver !== undefined) {
                if (options === undefined || options.globalEventIsActiveResolver === undefined ||
                    options.globalEventIsActiveResolver(createdModel, isCreate ? ProviderActionEnum.Create : ProviderActionEnum.Append)) {
                    (isCreate ? _this.create$ : _this.append$).next(createdModel);
                }
            }
            _this.createIsActive$.next(false);
            return createdModel;
        }));
    };
    RestProvider.prototype._update = function (key, model, isUpdate, options) {
        var _this = this;
        this.updateIsActive$.next(true);
        var useDefault = (options && options.useFakeHttpClient === true) || this.httpClient instanceof FakeHttpClient;
        model = this.plainToClass(model, ProviderActionEnum.Update, options && options.classTransformOptions ?
            options.classTransformOptions :
            undefined);
        var errors = classValidator.validateSync(model, options && options.classValidatorOptions ?
            options.classValidatorOptions :
            { validationError: { target: false } });
        if (errors.length > 0 && (!options || options.globalEventIsActive !== false)) {
            return _throw._throw(new ValidatorError(errors));
        }
        var object;
        var optionsList = [{ actionOptions: options }, (this.options)];
        var request;
        if (isUpdate === true) {
            object = this.classToPlain(model, ProviderActionEnum.Update, options && options.classTransformOptions ?
                options.classTransformOptions :
                undefined);
            var requestUrl = this.providerActionHandlers.getRequestUrl(key, object, optionsList, ProviderActionEnum.Update, useDefault);
            var requestOptions = this.providerActionHandlers.getRequestOptions(key, object, optionsList, ProviderActionEnum.Update, useDefault);
            request = this.providerActionHandlers.getRequest(requestUrl, object, requestOptions, optionsList, ProviderActionEnum.Update, useDefault);
            if (!request) {
                request = (options === undefined || options.useFakeHttpClient !== true ? this.httpClient : this.fakeHttpClient).
                    put(requestUrl, object, requestOptions);
            }
        }
        else {
            object = this.classToPlain(model, ProviderActionEnum.Patch, options && options.classTransformOptions ?
                options.classTransformOptions :
                undefined);
            var requestUrl = this.providerActionHandlers.getRequestUrl(key, object, optionsList, ProviderActionEnum.Patch, useDefault);
            var requestOptions = this.providerActionHandlers.getRequestOptions(key, object, optionsList, ProviderActionEnum.Patch, useDefault);
            request = this.providerActionHandlers.getRequest(requestUrl, object, requestOptions, optionsList, ProviderActionEnum.Patch, useDefault);
            if (!request) {
                request = this.httpClient.patch(requestUrl, object, requestOptions);
            }
        }
        return request.pipe(operators.map(function (responseData) { return _this.providerActionHandlers.getResponseData(responseData, optionsList, isUpdate ? ProviderActionEnum.Update : ProviderActionEnum.Patch, useDefault); }), operators.map(function (updatedItem) {
            var updatedModel = _this.plainToClass(updatedItem, isUpdate ? ProviderActionEnum.Update : ProviderActionEnum.Patch);
            var index = _this.items$.getValue().findIndex(function (eachModel) { return eachModel.id === key; });
            if (index !== -1) {
                _this.items$.next(_this.items$.getValue().set(index, updatedModel));
                _this.reconfigItems();
            }
            if (options === undefined ||
                options.globalEventIsActive !== false ||
                options.globalEventIsActiveResolver !== undefined) {
                if (options === undefined || options.globalEventIsActiveResolver === undefined ||
                    options.globalEventIsActiveResolver(updatedModel, isUpdate ? ProviderActionEnum.Update : ProviderActionEnum.Patch)) {
                    (isUpdate ? _this.update$ : _this.patch$).next(updatedModel);
                }
            }
            _this.updateIsActive$.next(false);
            return updatedModel;
        }));
    };
    RestProvider.prototype.update = function (key, model, options) {
        return this._update(key, model, true, options);
    };
    RestProvider.prototype.patch = function (key, model, options) {
        return this._update(key, model, false, options);
    };
    RestProvider.prototype.load = function (key, options) {
        var _this = this;
        this.loadIsActive$.next(true);
        var useDefault = (options && options.useFakeHttpClient === true) || this.httpClient instanceof FakeHttpClient;
        var optionsList = [{ actionOptions: options }, (this.options)];
        var requestUrl = this.providerActionHandlers.getRequestUrl(key, undefined, optionsList, ProviderActionEnum.Load, useDefault);
        var requestOptions = this.providerActionHandlers.getRequestOptions(key, undefined, optionsList, ProviderActionEnum.Load, useDefault);
        var request = this.providerActionHandlers.getRequest(requestUrl, undefined, requestOptions, optionsList, ProviderActionEnum.Load, useDefault);
        if (!request) {
            request = (options === undefined || options.useFakeHttpClient !== true ? this.httpClient : this.fakeHttpClient).
                get(requestUrl, requestOptions);
        }
        return request.pipe(operators.map(function (responseData) { return _this.providerActionHandlers.getResponseData(responseData, optionsList, ProviderActionEnum.Load, useDefault); }), operators.map(function (loadedItem) {
            var loadedModel = _this.plainToClass(loadedItem, ProviderActionEnum.Load, options && options.classTransformOptions ?
                options.classTransformOptions :
                undefined);
            var index = _this.items$.getValue().findIndex(function (eachModel) { return eachModel.id === key; });
            if (index !== -1) {
                _this.items$.next(_this.items$.getValue().set(index, loadedModel));
            }
            if (options === undefined ||
                options.globalEventIsActive !== false ||
                options.globalEventIsActiveResolver !== undefined) {
                if (options === undefined || options.globalEventIsActiveResolver === undefined ||
                    options.globalEventIsActiveResolver(loadedModel, ProviderActionEnum.Load)) {
                    _this.load$.next(loadedModel);
                }
            }
            _this.loadIsActive$.next(false);
            return loadedModel;
        }));
    };
    RestProvider.prototype.delete = function (key, options) {
        var _this = this;
        this.deleteIsActive$.next(true);
        var useDefault = (options && options.useFakeHttpClient === true) || this.httpClient instanceof FakeHttpClient;
        var optionsList = [{ actionOptions: options }, (this.options)];
        var requestUrl = this.providerActionHandlers.getRequestUrl(key, undefined, optionsList, ProviderActionEnum.Delete, useDefault);
        var requestOptions = this.providerActionHandlers.getRequestOptions(key, undefined, optionsList, ProviderActionEnum.Delete, useDefault);
        var request = this.providerActionHandlers.getRequest(requestUrl, undefined, requestOptions, optionsList, ProviderActionEnum.Delete, useDefault);
        if (!request) {
            request = (options === undefined || options.useFakeHttpClient !== true ? this.httpClient : this.fakeHttpClient).
                delete(requestUrl, requestOptions);
        }
        return request.pipe(operators.map(function (responseData) { return _this.providerActionHandlers.getResponseData(responseData, optionsList, ProviderActionEnum.Delete, useDefault); }), operators.map(function (deleted) {
            var index = _this.items$.getValue().findIndex(function (eachModel) { return eachModel.id === key; });
            var deletedModel = _this.items$.getValue().get(index);
            if (index !== -1) {
                _this.items$.next(_this.items$.getValue().delete(index));
                var paginationMeta = _this.paginationMeta$.getValue();
                var newPaginationMeta = _this.calcPaginationMeta({
                    totalResults: paginationMeta.totalResults === 0 ? 0 : paginationMeta.totalResults - 1
                });
                _this.reconfigItems();
            }
            if (options === undefined ||
                options.globalEventIsActive !== false ||
                options.globalEventIsActiveResolver !== undefined) {
                if (options === undefined || options.globalEventIsActiveResolver === undefined ||
                    options.globalEventIsActiveResolver(deletedModel, ProviderActionEnum.Delete)) {
                    _this.delete$.next(deletedModel);
                }
            }
            _this.deleteIsActive$.next(false);
            return deletedModel;
        }));
    };
    RestProvider.prototype.reloadAll = function () {
        this._loadAll(this.filter, this.prevOptions).pipe(operators.first()).subscribe();
    };
    RestProvider.prototype.loadAll = function (filter, options) {
        filter = Object.assign({}, filter);
        var searchText = filter[this.restOptions.searchTextQueryParam] || filter.searchText;
        delete filter.searchText;
        this.calcPaginationMeta({
            curPage: filter[this.restOptions.pageQueryParam] || filter.curPage,
            perPage: filter[this.restOptions.limitQueryParam] || filter.perPage
        });
        delete filter.curPage;
        delete filter.perPage;
        filter[this.restOptions.searchTextQueryParam] = searchText;
        return this._loadAll(filter, options);
    };
    RestProvider.prototype._loadAll = function (filter, options) {
        var _this = this;
        this.loadAllIsActive$.next(true);
        var useDefault = (options && options.useFakeHttpClient === true) || this.httpClient instanceof FakeHttpClient;
        var optionsList = [{ actionOptions: options }, (this.options)];
        var paginationMeta = this.paginationMeta$.getValue();
        this.filter = filter ? Object.assign({}, filter) : {};
        for (var key in this.filter) {
            if (this.filter.hasOwnProperty(key) && !this.filter[key]) {
                delete this.filter[key];
            }
        }
        this.prevOptions = options;
        var requestUrl = this.providerActionHandlers.getRequestUrl(undefined, this.filter, optionsList, ProviderActionEnum.LoadAll, useDefault);
        this.filter[this.restOptions.pageQueryParam] = paginationMeta.curPage;
        this.filter[this.restOptions.limitQueryParam] = paginationMeta.perPage;
        requestUrl = this.providerActionHandlers.getRequestQuery(requestUrl, this.filter, optionsList, ProviderActionEnum.LoadAll, useDefault);
        var requestOptions = this.providerActionHandlers.getRequestOptions(undefined, this.filter, optionsList, ProviderActionEnum.LoadAll, useDefault);
        var request = this.providerActionHandlers.getRequest(requestUrl, undefined, requestOptions, optionsList, ProviderActionEnum.LoadAll, useDefault);
        if (!request) {
            request = (options === undefined || options.useFakeHttpClient !== true ? this.httpClient : this.fakeHttpClient).
                get(requestUrl, requestOptions);
        }
        return request.pipe(operators.map(function (responseData) {
            var responsePaginationMeta = _this.providerActionHandlers.getResponsePaginationMeta(responseData, optionsList, ProviderActionEnum.LoadAll, useDefault);
            if (responsePaginationMeta) {
                _this.calcPaginationMeta(Object.assign({ curPage: paginationMeta.curPage, perPage: paginationMeta.perPage }, responsePaginationMeta));
            }
            else {
                _this.calcPaginationMeta({
                    curPage: paginationMeta.curPage,
                    perPage: paginationMeta.perPage
                });
            }
            return _this.providerActionHandlers.getResponseData(responseData, optionsList, ProviderActionEnum.LoadAll, useDefault);
        }), operators.map(function (loadedItems) {
            var loadedModels = loadedItems === undefined ? [] : loadedItems.map(function (loadedItem) { return _this.plainToClass(loadedItem, ProviderActionEnum.LoadAll, options && options.classTransformOptions ?
                options.classTransformOptions :
                undefined); });
            _this.items$.next(immutable.List(loadedModels));
            _this.reconfigItems();
            if (options === undefined ||
                options.globalEventIsActive !== false ||
                options.globalEventIsActiveResolver !== undefined) {
                if (options === undefined || options.globalEventIsActiveResolver === undefined ||
                    options.globalEventIsActiveResolver(loadedModels, ProviderActionEnum.LoadAll)) {
                    _this.loadAll$.next(loadedModels);
                }
            }
            _this.loadAllIsActive$.next(false);
            return loadedModels;
        }));
    };
    RestProvider.prototype.reconfigItems = function () {
        var paginationMeta = this.paginationMeta$.getValue();
        if (paginationMeta.perPage === undefined) {
            throw new ProviderError('Not set perPage count');
        }
        this.items$.next(immutable.List(this.items$.getValue().take(paginationMeta.perPage)));
    };
    return RestProvider;
}(Provider));
var MockProvider = /** @class */ (function (_super) {
    __extends(MockProvider, _super);
    function MockProvider(injector, factoryModel, options) {
        var _this = _super.call(this, injector, factoryModel, options) || this;
        _this.injector = injector;
        _this.factoryModel = factoryModel;
        _this.options = options;
        return _this;
    }
    MockProvider.prototype.init = function () {
        this.httpClient = this.fakeHttpClient;
        this.providerActionHandlers = this.injector.get(MockProviderActionHandlers);
        this.setOptions((this.options));
    };
    MockProvider.prototype.setOptions = function (options) {
        if (this.apiUrl === undefined) {
            this.apiUrl = 'http://fake/api';
        }
        if (this.pluralName === undefined) {
            this.pluralName = 'entities';
        }
        if (this.name === undefined) {
            this.name = 'entity';
        }
        if (options && options.items) {
            ((this.httpClient)).setItems(options.items);
        }
        _super.prototype.setOptions.call(this, options);
    };
    return MockProvider;
}(RestProvider));
var Repository = /** @class */ (function () {
    function Repository(injector, factoryModel, factoryMockProvider, factoryRestProvider) {
        this.injector = injector;
        this.factoryModel = factoryModel;
        this.factoryMockProvider = factoryMockProvider;
        this.factoryRestProvider = factoryRestProvider;
        this.mockProviders = [];
        this.restProviders = [];
        this._mockProviderIsActive = false;
        this._restProviderIsActive = false;
        this.destroyed$ = new Subject.Subject();
    }
    Object.defineProperty(Repository.prototype, "provider", {
        get: function () {
            if (this._mockProviderIsActive && this.mockProvider !== undefined) {
                return this.mockProvider;
            }
            if (this._restProviderIsActive && this.restProvider !== undefined) {
                return this.restProvider;
            }
            return new Provider(this.injector, this.factoryModel);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Repository.prototype, "paginationMeta$", {
        get: function () {
            return this.provider.paginationMeta$;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Repository.prototype, "providers", {
        get: function () {
            return __spread([this.restProvider], this.restProviders, [this.mockProvider], this.mockProviders);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Repository.prototype, "items", {
        get: function () {
            return this.provider.items$.getValue().toArray();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Repository.prototype, "items$", {
        get: function () {
            return this.provider.items$.pipe(operators.map(function (items) { return items.toArray(); }));
        },
        enumerable: true,
        configurable: true
    });
    Repository.prototype.ngOnDestroy = function () {
        this.destroyed$.next(true);
        this.destroyed$.complete();
    };
    Repository.prototype.fork = function (newFactoryModel, newFactoryMockProvider, newFactoryRestProvider) {
        if (this.root !== undefined) {
            return this.root.fork(newFactoryModel, newFactoryMockProvider, newFactoryRestProvider);
        }
        var newInstance = new Repository(this.injector, newFactoryModel ? newFactoryModel : (this.factoryModel), newFactoryMockProvider ? newFactoryMockProvider : (this.factoryMockProvider), newFactoryRestProvider ? newFactoryRestProvider : (this.factoryRestProvider));
        newInstance.root = (this);
        return newInstance;
    };
    Repository.prototype.useMock = function (options) {
        this._restProviderIsActive = false;
        this._mockProviderIsActive = true;
        if (this.mockProvider === undefined && options !== undefined) {
            this.mockProvider = ((this.factoryMockProvider ? new this.factoryMockProvider(this.injector, this.factoryModel, options) : new MockProvider(this.injector, this.factoryModel, options)));
            this.mockProvider.name = 'Mock#' + this.root.mockProviders.length.toString();
            if (this.root !== undefined) {
                this.root.subscribeToProvider(this.mockProvider);
                this.root.mockProviders.push(this.mockProvider);
            }
        }
        else {
            this.mockProvider.name = 'Mock#root';
            this.mockProvider.setOptions(options);
            this.subscribeToProvider(this.mockProvider);
        }
    };
    Repository.prototype.useRest = function (options) {
        this._restProviderIsActive = true;
        this._mockProviderIsActive = false;
        if (this.restProvider === undefined && options !== undefined) {
            this.restProvider = ((this.factoryRestProvider ? new this.factoryRestProvider(this.injector, this.factoryModel, options) : new RestProvider(this.injector, this.factoryModel, options)));
            this.restProvider.name = 'Rest#' + this.root.restProviders.length.toString();
            if (this.root !== undefined) {
                this.root.subscribeToProvider(this.restProvider);
                this.root.restProviders.push(this.restProvider);
            }
        }
        else {
            this.restProvider.name = 'Rest#root';
            this.restProvider.setOptions(options);
            this.subscribeToProvider(this.restProvider);
        }
    };
    Repository.prototype.subscribeToProvider = function (provider) {
        var _this = this;
        provider.create$.pipe(operators.takeUntil(this.destroyed$)).subscribe(function (item) {
            _this.providers.forEach(function (eachProvider) {
                var options = eachProvider ? eachProvider.getOptions() : undefined;
                if (eachProvider !== undefined &&
                    eachProvider.name !== provider.name &&
                    eachProvider.instanceofFactoryModel(item) &&
                    (options === undefined ||
                        (options.globalEventResolver === undefined ||
                            options.globalEventResolver(item, ProviderActionEnum.Create)))) {
                    eachProvider.create(item, { useFakeHttpClient: true, globalEventIsActive: false }).pipe(operators.first()).subscribe();
                }
            });
        });
        provider.append$.pipe(operators.takeUntil(this.destroyed$)).subscribe(function (item) {
            _this.providers.forEach(function (eachProvider) {
                var options = eachProvider ? eachProvider.getOptions() : undefined;
                if (eachProvider !== undefined &&
                    eachProvider.name !== provider.name &&
                    eachProvider.instanceofFactoryModel(item) &&
                    (options === undefined ||
                        (options.globalEventResolver === undefined ||
                            options.globalEventResolver(item, ProviderActionEnum.Create)))) {
                    eachProvider.append(item, { useFakeHttpClient: true, globalEventIsActive: false }).pipe(operators.first()).subscribe();
                }
            });
        });
        provider.update$.pipe(operators.takeUntil(this.destroyed$)).subscribe(function (item) {
            _this.providers.forEach(function (eachProvider) {
                var options = eachProvider ? eachProvider.getOptions() : undefined;
                if (eachProvider !== undefined &&
                    eachProvider.name !== provider.name) {
                    if (eachProvider.instanceofFactoryModel(item) &&
                        (options === undefined ||
                            (options.globalEventResolver === undefined ||
                                options.globalEventResolver(item, ProviderActionEnum.Update)))) {
                        eachProvider.update(item.id, item, { useFakeHttpClient: true, globalEventIsActive: false }).pipe(operators.first()).subscribe();
                    }
                    if (eachProvider.instanceofNestedFactoryModel(item)) {
                        eachProvider.updateNestedFactoryModel(item);
                    }
                }
            });
        });
        provider.patch$.pipe(operators.takeUntil(this.destroyed$)).subscribe(function (item) {
            _this.providers.forEach(function (eachProvider) {
                var options = eachProvider ? eachProvider.getOptions() : undefined;
                if (eachProvider !== undefined &&
                    eachProvider.name !== provider.name) {
                    if (eachProvider.instanceofFactoryModel(item) &&
                        (options === undefined ||
                            (options.globalEventResolver === undefined ||
                                options.globalEventResolver(item, ProviderActionEnum.Patch)))) {
                        eachProvider.patch(item.id, item, { useFakeHttpClient: true, globalEventIsActive: false }).pipe(operators.first()).subscribe();
                    }
                }
            });
        });
        provider.delete$.pipe(operators.takeUntil(this.destroyed$)).subscribe(function (item) {
            _this.providers.forEach(function (eachProvider) {
                var options = eachProvider ? eachProvider.getOptions() : undefined;
                if (eachProvider !== undefined &&
                    eachProvider.name !== provider.name) {
                    if (eachProvider.instanceofFactoryModel(item) &&
                        (options === undefined ||
                            (options.globalEventResolver === undefined ||
                                options.globalEventResolver(item, ProviderActionEnum.Delete)))) {
                        eachProvider.delete(item.id, { useFakeHttpClient: true, globalEventIsActive: false }).pipe(operators.first()).subscribe();
                    }
                    if (eachProvider.instanceofNestedFactoryModel(item)) {
                        eachProvider.deleteNestedFactoryModel(item);
                    }
                }
            });
        });
        provider.load$.pipe(operators.takeUntil(this.destroyed$)).subscribe(function (item) {
            _this.providers.forEach(function (eachProvider) {
                var options = eachProvider ? eachProvider.getOptions() : undefined;
                if (eachProvider !== undefined &&
                    eachProvider.name !== provider.name &&
                    eachProvider.instanceofFactoryModel(item) &&
                    (options === undefined ||
                        (options.globalEventResolver === undefined ||
                            options.globalEventResolver(item, ProviderActionEnum.Update)))) {
                    eachProvider.update(item.id, item, { useFakeHttpClient: true, globalEventIsActive: false }).pipe(operators.first()).subscribe();
                }
            });
        });
        provider.loadAll$.pipe(operators.takeUntil(this.destroyed$)).subscribe(function (items) {
            items.forEach(function (item) { return _this.providers.forEach(function (eachProvider) {
                var options = eachProvider ? eachProvider.getOptions() : undefined;
                if (eachProvider !== undefined &&
                    eachProvider.name !== provider.name &&
                    eachProvider.instanceofFactoryModel(item) &&
                    (options === undefined ||
                        (options.globalEventResolver === undefined ||
                            options.globalEventResolver(item, ProviderActionEnum.Update)))) {
                    eachProvider.update(item.id, item, { useFakeHttpClient: true, globalEventIsActive: false }).pipe(operators.first()).subscribe();
                }
            }); });
        });
    };
    Repository.prototype.setOptions = function (options) {
        this.provider.setOptions(options);
    };
    Repository.prototype.action = function (key, data, options) {
        return this.provider.action(key, data, options).pipe(operators.first());
    };
    Repository.prototype.save = function (model, options) {
        return this.provider.save(model, options).pipe(operators.first());
    };
    Repository.prototype.create = function (model, options) {
        return this.provider.create(model, options).pipe(operators.first());
    };
    Repository.prototype.update = function (key, model, options) {
        return this.provider.update(key, model, options).pipe(operators.first());
    };
    Repository.prototype.patch = function (key, model, options) {
        return this.provider.patch(key, model, options).pipe(operators.first());
    };
    Repository.prototype.load = function (key, options) {
        return this.provider.load(key, options).pipe(operators.first());
    };
    Repository.prototype.delete = function (key, options) {
        return this.provider.delete(key, options).pipe(operators.first());
    };
    Repository.prototype.reloadAll = function () {
        this.provider.reloadAll();
    };
    Repository.prototype.loadAll = function (filter, options) {
        return this.provider.loadAll(filter, options);
    };
    Repository.prototype.clone = function (model) {
        return this.provider.classToClass(model);
    };
    return Repository;
}());
var DynamicRepository = /** @class */ (function (_super) {
    __extends(DynamicRepository, _super);
    function DynamicRepository(injector) {
        var _this = _super.call(this, injector, Model) || this;
        _this.injector = injector;
        return _this;
    }
    return DynamicRepository;
}(Repository));
DynamicRepository.decorators = [
    { type: core.Injectable },
];
DynamicRepository.ctorParameters = function () { return [
    { type: core.Injector, },
]; };
var NgxRepositoryModule = /** @class */ (function () {
    function NgxRepositoryModule() {
    }
    NgxRepositoryModule.forRoot = function () {
        return {
            ngModule: NgxRepositoryModule,
            providers: []
        };
    };
    return NgxRepositoryModule;
}());
NgxRepositoryModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule
                ],
                providers: [
                    RestProviderActionHandlers,
                    MockProviderActionHandlers,
                    DynamicRepository
                ],
            },] },
];
var NgxRepositoryModules = [NgxRepositoryModule.forRoot()];
var NgxRepositoryShareds = [ProviderActionEnum, ProviderError, ValidatorError, Model, PaginationMeta, MockProviderActionHandlers, MockProvider, Provider, RestProviderActionHandlers, RestProvider, DynamicRepository, Repository, FakeHttpClient];

exports.NgxRepositoryModule = NgxRepositoryModule;
exports.ProviderActionEnum = ProviderActionEnum;
exports.ProviderError = ProviderError;
exports.ValidatorError = ValidatorError;
exports.Model = Model;
exports.PaginationMeta = PaginationMeta;
exports.MockProviderActionHandlers = MockProviderActionHandlers;
exports.MockProvider = MockProvider;
exports.Provider = Provider;
exports.RestProviderActionHandlers = RestProviderActionHandlers;
exports.RestProvider = RestProvider;
exports.DynamicRepository = DynamicRepository;
exports.Repository = Repository;
exports.FakeHttpClient = FakeHttpClient;
exports.NgxRepositoryModules = NgxRepositoryModules;
exports.NgxRepositoryShareds = NgxRepositoryShareds;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-repository.umd.js.map
